/*
 *    Contour Union Algorithm    c-union4.h
 *    (nonrecursive algorithm, nonrecursive data structure)
 *    Copyright (c) 1994,1995 I.Povazan, T.Hruz, R.Gosiorovsky
 */

#define LOGMAX 10

CHAR flag[LOGMAX];               

CHAR spy_left4(INT A,INT B)      
 {
	while( A+1 != B )
		{                         
		if (I[A+B]) return(TRUE);
		B=(A+B)>>1;
		}
	if (I[A+B]) return(TRUE);
	return(FALSE);
 }  

CHAR spy_right4(INT A,INT B)	   
 {
	while( A+1 != B )
		{                             
		if (I[A+B]) return(TRUE);
		A=(A+B)>>1;
		}
	if (I[A+B]) return(TRUE);
	return(FALSE);
 }  

VOID onion4(INT a,INT b,INT A,INT B)
{
    INT stred,Afork,Bfork,deepfork,deep;

    deep=LOGMAX-1;
    flag[deep]= -1;
    while ( deep )
	{
	if ( I[A+B] ) return;
	stred=(A+B)>>1 ;
	if (a<stred)
	    {
	    if (b>stred)
		{
		if( (A==a) && (B==b) )
		    {
		    if (!spy_left4(A,B))   Point(XL,YL);
		    if (!spy_right4(A,B))  Point(XR,YR);
		    I[A+B] = TRUE;
		    goto backtrace;   
		    }
		Afork=A; Bfork=B; deepfork=deep;
		break;
		}
	    else
		{
		flag[--deep]=1;       
		B=stred;
		}
	    }
	else
	    {
	    if (b>stred)
		{
		flag[--deep]=0;        
		A=stred;
		}
	    else
		{
 		printf("\nERROR - 1\n");
		}
	    }
	}

    if(deep==0) 
	{
	if ( I[A+B] ) return;
	Point(XL,YL); 
	Point(XR,YR); 
	I[A+B] = TRUE;
	goto backtrace;     
	}

    if(a!=Afork)
	{
	if(b!=Bfork) 
	    {
	    flag[--deep]=1; 
	    A=Afork;
	    B=(Afork+Bfork)>>1;
	    }
	while ( 1 )
	    {
	    if ( I[A+B] ) break;
	    stred=(A+B)>>1;
	    if (a<stred)
		{
		if( !(I[stred+B]) )
		    {
		    if( B==b ) if (!spy_right4(A,B)) Point(XR,YR);
		    I[stred+B] = TRUE;
		    } 
		flag[--deep]=1;	
		B=stred;
		}
	    else
		{
		flag[--deep]=0; 
		A=stred;
		if(a==A)
		    {
		    if(I[A+B])
			{
			break;
			}
		    else
			{
			if (!spy_left4(A,B)) Point(XL,YL); 
			I[A+B] = TRUE;
			break;
			}
		    }
		}
	    } 
	} 

    while( deep != deepfork )
	{
	if( flag[deep] ) 
	    {
	    stred=B<<1;
	    if( I[B+stred-A] )
		{
		I[stred]=TRUE;
		++deep;  
		B=stred-A;
		}
	    else  break;
	    }
	else	 
	    {
	    stred=A<<1;
	    if( I[stred-B+A] )
		{
		I[stred]=TRUE;
		++deep;
		A=stred-B;
		}
	    else  break;
	    }
	}

    deep=deepfork;
    if(b!=Bfork)
	{
	if(a!=Afork)  
	    {
	    flag[--deep]=0; 
	    A=(Afork+Bfork)>>1;
	    B=Bfork;
	    }
	while ( 1 )
	    {
	    if ( I[A+B] ) break;
	    stred=(A+B)>>1;
	    if (b>stred)
		{
		if( !(I[A+stred]) )
		    {
		    if( a==A ) if (!spy_left4(A,B)) Point(XL,YL); 
		    I[A+stred] = TRUE;
		    }
		flag[--deep]=0;	
		A=stred;
		}
	    else
		{
		flag[--deep]=1; 
		B=stred;
		if(b==B)
		    {
		    if(I[A+B])
			{
			break;
			}
		    else
			{
			if (!spy_right4(A,B)) Point(XR,YR); 
			I[A+B] = TRUE;
			break;
			}
		    }
		}
	    } 
	} 

backtrace:
    while( flag[deep] >= 0 )
	{
	if( flag[deep] ) 
	    {
	    stred=B<<1;
	    if( I[B+stred-A] )
		{
		I[stred]=TRUE;
		++deep;   
		B=stred-A;
		}
	    else  return;
	    }
	else	  
	    {
	    stred=A<<1;
	    if( I[stred-B+A] )
		{
		I[stred]=TRUE;
		++deep;
		A=stred-B;
		}
	    else  return;
	    }
	}
    return;
}
/*------------------------------------------------------------------*/
